/*
Copyright 2021 The Crossplane Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	clientset "github.com/crossplane/crossplane/internal/client/clientset/versioned"
	apiextensionsv1 "github.com/crossplane/crossplane/internal/client/clientset/versioned/typed/apiextensions/v1"
	fakeapiextensionsv1 "github.com/crossplane/crossplane/internal/client/clientset/versioned/typed/apiextensions/v1/fake"
	pkgv1 "github.com/crossplane/crossplane/internal/client/clientset/versioned/typed/pkg/v1"
	fakepkgv1 "github.com/crossplane/crossplane/internal/client/clientset/versioned/typed/pkg/v1/fake"
	pkgv1alpha1 "github.com/crossplane/crossplane/internal/client/clientset/versioned/typed/pkg/v1alpha1"
	fakepkgv1alpha1 "github.com/crossplane/crossplane/internal/client/clientset/versioned/typed/pkg/v1alpha1/fake"
	pkgv1beta1 "github.com/crossplane/crossplane/internal/client/clientset/versioned/typed/pkg/v1beta1"
	fakepkgv1beta1 "github.com/crossplane/crossplane/internal/client/clientset/versioned/typed/pkg/v1beta1/fake"
	secretsv1alpha1 "github.com/crossplane/crossplane/internal/client/clientset/versioned/typed/secrets/v1alpha1"
	fakesecretsv1alpha1 "github.com/crossplane/crossplane/internal/client/clientset/versioned/typed/secrets/v1alpha1/fake"
	"k8s.io/apimachinery/pkg/runtime"
	"k8s.io/apimachinery/pkg/watch"
	"k8s.io/client-go/discovery"
	fakediscovery "k8s.io/client-go/discovery/fake"
	"k8s.io/client-go/testing"
)

// NewSimpleClientset returns a clientset that will respond with the provided objects.
// It's backed by a very simple object tracker that processes creates, updates and deletions as-is,
// without applying any validations and/or defaults. It shouldn't be considered a replacement
// for a real clientset and is mostly useful in simple unit tests.
func NewSimpleClientset(objects ...runtime.Object) *Clientset {
	o := testing.NewObjectTracker(scheme, codecs.UniversalDecoder())
	for _, obj := range objects {
		if err := o.Add(obj); err != nil {
			panic(err)
		}
	}

	cs := &Clientset{tracker: o}
	cs.discovery = &fakediscovery.FakeDiscovery{Fake: &cs.Fake}
	cs.AddReactor("*", "*", testing.ObjectReaction(o))
	cs.AddWatchReactor("*", func(action testing.Action) (handled bool, ret watch.Interface, err error) {
		gvr := action.GetResource()
		ns := action.GetNamespace()
		watch, err := o.Watch(gvr, ns)
		if err != nil {
			return false, nil, err
		}
		return true, watch, nil
	})

	return cs
}

// Clientset implements clientset.Interface. Meant to be embedded into a
// struct to get a default implementation. This makes faking out just the method
// you want to test easier.
type Clientset struct {
	testing.Fake
	discovery *fakediscovery.FakeDiscovery
	tracker   testing.ObjectTracker
}

func (c *Clientset) Discovery() discovery.DiscoveryInterface {
	return c.discovery
}

func (c *Clientset) Tracker() testing.ObjectTracker {
	return c.tracker
}

var (
	_ clientset.Interface = &Clientset{}
	_ testing.FakeClient  = &Clientset{}
)

// ApiextensionsV1 retrieves the ApiextensionsV1Client
func (c *Clientset) ApiextensionsV1() apiextensionsv1.ApiextensionsV1Interface {
	return &fakeapiextensionsv1.FakeApiextensionsV1{Fake: &c.Fake}
}

// PkgV1alpha1 retrieves the PkgV1alpha1Client
func (c *Clientset) PkgV1alpha1() pkgv1alpha1.PkgV1alpha1Interface {
	return &fakepkgv1alpha1.FakePkgV1alpha1{Fake: &c.Fake}
}

// PkgV1beta1 retrieves the PkgV1beta1Client
func (c *Clientset) PkgV1beta1() pkgv1beta1.PkgV1beta1Interface {
	return &fakepkgv1beta1.FakePkgV1beta1{Fake: &c.Fake}
}

// PkgV1 retrieves the PkgV1Client
func (c *Clientset) PkgV1() pkgv1.PkgV1Interface {
	return &fakepkgv1.FakePkgV1{Fake: &c.Fake}
}

// SecretsV1alpha1 retrieves the SecretsV1alpha1Client
func (c *Clientset) SecretsV1alpha1() secretsv1alpha1.SecretsV1alpha1Interface {
	return &fakesecretsv1alpha1.FakeSecretsV1alpha1{Fake: &c.Fake}
}
